import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:flutter/cupertino.dart';
import 'package:hive/hive.dart';

mixin Restorable<T> on Presenter {
  Box<T> _box;

  String get key;
  //todo: delete
  void Function() get registerAdapters;

  @override
  @mustCallSuper
  Future<T> init() async {
    registerAdapters();
    _box = await Hive.openBox(key);
    return _box.get('auth');
  }

  @mustCallSuper
  Future<void> close() async {
    await _box.close();
  }

  void save(T value) {
    _box.put(key, value);
  }
}
